#!/usr/bin/perl
use warnings;
use WWW::Curl::Easy;

#Service details
my $service_id = "example.com";
my $service_secret = "servicesecret";

#Notifications recipient
my $user = <NID>;
my $encoded_nid = urlencode($user);

#This example uses the Notification id for pushing the notification
my $request_uri = "https://alpha.one.ovi.com/nnapi/1.0/nid/$encoded_nid";
my $request_parameters = "payload=Test Notification from REST API";

#Initialize curl 
my $curl = WWW::Curl::Easy->new;
$curl->setopt(CURLOPT_URL, $request_uri);
$curl->setopt(CURLOPT_POST, 1); #TRUE
$curl->setopt(CURLOPT_POSTFIELDS, $request_parameters);
$curl->setopt(CURLOPT_HTTPAUTH, 2); #CURLAUTH_DIGEST
$curl->setopt(CURLOPT_USERPWD, "$service_id:$service_secret");

#Excute the request
my $retcode = $curl->perform;

if ($retcode == 0) {
    my $response_code = $curl->getinfo(CURLINFO_HTTP_CODE);
    print "\nHTTP Response from Notifications API: $response_code\n";
} else {
    print("\nAn error happened: $retcode ".$curl->strerror($retcode)." ".$curl->errbuf."\n");
}

#Does the encoding for user nid
sub urlencode {
    my $s = shift;
    $s =~ s/([^-A-Za-z0-9_.!~*'() ])/sprintf("%%%02X", ord($1))/eg;
    $s =~ tr/ /+/;
    return $s;
}